]> git.ipfire.org Git - thirdparty/git.git/blob - git-submodule.sh
t5318: avoid unnecessary command substitutions
[thirdparty/git.git] / git-submodule.sh
1 #!/bin/sh
2 #
3 # git-submodule.sh: add, init, update or list git submodules
4 #
5 # Copyright (c) 2007 Lars Hjemli
6
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--] [<path>...]
13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
14 or: $dashless [--quiet] foreach [--recursive] <command>
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]
16 or: $dashless [--quiet] absorbgitdirs [--] [<path>...]"
17 OPTIONS_SPEC=
18 SUBDIRECTORY_OK=Yes
19 . git-sh-setup
20 . git-parse-remote
21 require_work_tree
22 wt_prefix=$(git rev-parse --show-prefix)
23 cd_to_toplevel
24
25 # Tell the rest of git that any URLs we get don't come
26 # directly from the user, so it can apply policy as appropriate.
27 GIT_PROTOCOL_FROM_USER=0
28 export GIT_PROTOCOL_FROM_USER
29
30 command=
31 branch=
32 force=
33 reference=
34 cached=
35 recursive=
36 init=
37 files=
38 remote=
39 nofetch=
40 update=
41 prefix=
42 custom_name=
43 depth=
44 progress=
45 dissociate=
46
47 die_if_unmatched ()
48 {
49 if test "$1" = "#unmatched"
50 then
51 exit ${2:-1}
52 fi
53 }
54
55 #
56 # Print a submodule configuration setting
57 #
58 # $1 = submodule name
59 # $2 = option name
60 # $3 = default value
61 #
62 # Checks in the usual git-config places first (for overrides),
63 # otherwise it falls back on .gitmodules. This allows you to
64 # distribute project-wide defaults in .gitmodules, while still
65 # customizing individual repositories if necessary. If the option is
66 # not in .gitmodules either, print a default value.
67 #
68 get_submodule_config () {
69 name="$1"
70 option="$2"
71 default="$3"
72 value=$(git config submodule."$name"."$option")
73 if test -z "$value"
74 then
75 value=$(git config -f .gitmodules submodule."$name"."$option")
76 fi
77 printf '%s' "${value:-$default}"
78 }
79
80 isnumber()
81 {
82 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
83 }
84
85 # Sanitize the local git environment for use within a submodule. We
86 # can't simply use clear_local_git_env since we want to preserve some
87 # of the settings from GIT_CONFIG_PARAMETERS.
88 sanitize_submodule_env()
89 {
90 save_config=$GIT_CONFIG_PARAMETERS
91 clear_local_git_env
92 GIT_CONFIG_PARAMETERS=$save_config
93 export GIT_CONFIG_PARAMETERS
94 }
95
96 #
97 # Add a new submodule to the working tree, .gitmodules and the index
98 #
99 # $@ = repo path
100 #
101 # optional branch is stored in global branch variable
102 #
103 cmd_add()
104 {
105 # parse $args after "submodule ... add".
106 reference_path=
107 while test $# -ne 0
108 do
109 case "$1" in
110 -b | --branch)
111 case "$2" in '') usage ;; esac
112 branch=$2
113 shift
114 ;;
115 -f | --force)
116 force=$1
117 ;;
118 -q|--quiet)
119 GIT_QUIET=1
120 ;;
121 --progress)
122 progress=1
123 ;;
124 --reference)
125 case "$2" in '') usage ;; esac
126 reference_path=$2
127 shift
128 ;;
129 --reference=*)
130 reference_path="${1#--reference=}"
131 ;;
132 --dissociate)
133 dissociate=1
134 ;;
135 --name)
136 case "$2" in '') usage ;; esac
137 custom_name=$2
138 shift
139 ;;
140 --depth)
141 case "$2" in '') usage ;; esac
142 depth="--depth=$2"
143 shift
144 ;;
145 --depth=*)
146 depth=$1
147 ;;
148 --)
149 shift
150 break
151 ;;
152 -*)
153 usage
154 ;;
155 *)
156 break
157 ;;
158 esac
159 shift
160 done
161
162 if test -n "$reference_path"
163 then
164 is_absolute_path "$reference_path" ||
165 reference_path="$wt_prefix$reference_path"
166
167 reference="--reference=$reference_path"
168 fi
169
170 repo=$1
171 sm_path=$2
172
173 if test -z "$sm_path"; then
174 sm_path=$(printf '%s\n' "$repo" |
175 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
176 fi
177
178 if test -z "$repo" || test -z "$sm_path"; then
179 usage
180 fi
181
182 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
183
184 # assure repo is absolute or relative to parent
185 case "$repo" in
186 ./*|../*)
187 test -z "$wt_prefix" ||
188 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
189
190 # dereference source url relative to parent's url
191 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
192 ;;
193 *:*|/*)
194 # absolute url
195 realrepo=$repo
196 ;;
197 *)
198 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
199 ;;
200 esac
201
202 # normalize path:
203 # multiple //; leading ./; /./; /../; trailing /
204 sm_path=$(printf '%s/\n' "$sm_path" |
205 sed -e '
206 s|//*|/|g
207 s|^\(\./\)*||
208 s|/\(\./\)*|/|g
209 :start
210 s|\([^/]*\)/\.\./||
211 tstart
212 s|/*$||
213 ')
214 if test -z "$force"
215 then
216 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
217 die "$(eval_gettext "'\$sm_path' already exists in the index")"
218 else
219 git ls-files -s "$sm_path" | sane_grep -v "^160000" > /dev/null 2>&1 &&
220 die "$(eval_gettext "'\$sm_path' already exists in the index and is not a submodule")"
221 fi
222
223 if test -z "$force" &&
224 ! git add --dry-run --ignore-missing --no-warn-embedded-repo "$sm_path" > /dev/null 2>&1
225 then
226 eval_gettextln "The following path is ignored by one of your .gitignore files:
227 \$sm_path
228 Use -f if you really want to add it." >&2
229 exit 1
230 fi
231
232 if test -n "$custom_name"
233 then
234 sm_name="$custom_name"
235 else
236 sm_name="$sm_path"
237 fi
238
239 if ! git submodule--helper check-name "$sm_name"
240 then
241 die "$(eval_gettext "'$sm_name' is not a valid submodule name")"
242 fi
243
244 # perhaps the path exists and is already a git repo, else clone it
245 if test -e "$sm_path"
246 then
247 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
248 then
249 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
250 else
251 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
252 fi
253
254 else
255 if test -d ".git/modules/$sm_name"
256 then
257 if test -z "$force"
258 then
259 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
260 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
261 die "$(eval_gettextln "\
262 If you want to reuse this local git directory instead of cloning again from
263 \$realrepo
264 use the '--force' option. If the local git directory is not the correct repo
265 or you are unsure what this means choose another name with the '--name' option.")"
266 else
267 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
268 fi
269 fi
270 git submodule--helper clone ${GIT_QUIET:+--quiet} ${progress:+"--progress"} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${dissociate:+"--dissociate"} ${depth:+"$depth"} || exit
271 (
272 sanitize_submodule_env
273 cd "$sm_path" &&
274 # ash fails to wordsplit ${branch:+-b "$branch"...}
275 case "$branch" in
276 '') git checkout -f -q ;;
277 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
278 esac
279 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
280 fi
281 git config submodule."$sm_name".url "$realrepo"
282
283 git add --no-warn-embedded-repo $force "$sm_path" ||
284 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
285
286 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
287 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
288 if test -n "$branch"
289 then
290 git config -f .gitmodules submodule."$sm_name".branch "$branch"
291 fi &&
292 git add --force .gitmodules ||
293 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
294
295 # NEEDSWORK: In a multi-working-tree world, this needs to be
296 # set in the per-worktree config.
297 if git config --get submodule.active >/dev/null
298 then
299 # If the submodule being adding isn't already covered by the
300 # current configured pathspec, set the submodule's active flag
301 if ! git submodule--helper is-active "$sm_path"
302 then
303 git config submodule."$sm_name".active "true"
304 fi
305 else
306 git config submodule."$sm_name".active "true"
307 fi
308 }
309
310 #
311 # Execute an arbitrary command sequence in each checked out
312 # submodule
313 #
314 # $@ = command to execute
315 #
316 cmd_foreach()
317 {
318 # parse $args after "submodule ... foreach".
319 while test $# -ne 0
320 do
321 case "$1" in
322 -q|--quiet)
323 GIT_QUIET=1
324 ;;
325 --recursive)
326 recursive=1
327 ;;
328 -*)
329 usage
330 ;;
331 *)
332 break
333 ;;
334 esac
335 shift
336 done
337
338 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper foreach ${GIT_QUIET:+--quiet} ${recursive:+--recursive} "$@"
339 }
340
341 #
342 # Register submodules in .git/config
343 #
344 # $@ = requested paths (default to all)
345 #
346 cmd_init()
347 {
348 # parse $args after "submodule ... init".
349 while test $# -ne 0
350 do
351 case "$1" in
352 -q|--quiet)
353 GIT_QUIET=1
354 ;;
355 --)
356 shift
357 break
358 ;;
359 -*)
360 usage
361 ;;
362 *)
363 break
364 ;;
365 esac
366 shift
367 done
368
369 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper init ${GIT_QUIET:+--quiet} "$@"
370 }
371
372 #
373 # Unregister submodules from .git/config and remove their work tree
374 #
375 cmd_deinit()
376 {
377 # parse $args after "submodule ... deinit".
378 deinit_all=
379 while test $# -ne 0
380 do
381 case "$1" in
382 -f|--force)
383 force=$1
384 ;;
385 -q|--quiet)
386 GIT_QUIET=1
387 ;;
388 --all)
389 deinit_all=t
390 ;;
391 --)
392 shift
393 break
394 ;;
395 -*)
396 usage
397 ;;
398 *)
399 break
400 ;;
401 esac
402 shift
403 done
404
405 git ${wt_prefix:+-C "$wt_prefix"} submodule--helper deinit ${GIT_QUIET:+--quiet} ${prefix:+--prefix "$prefix"} ${force:+--force} ${deinit_all:+--all} "$@"
406 }
407
408 is_tip_reachable () (
409 sanitize_submodule_env &&
410 cd "$1" &&
411 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
412 test -z "$rev"
413 )
414
415 fetch_in_submodule () (
416 sanitize_submodule_env &&
417 cd "$1" &&
418 case "$2" in
419 '')
420 git fetch ;;
421 *)
422 shift
423 git fetch $(get_default_remote) "$@" ;;
424 esac
425 )
426
427 #
428 # Update each submodule path to correct revision, using clone and checkout as needed
429 #
430 # $@ = requested paths (default to all)
431 #
432 cmd_update()
433 {
434 # parse $args after "submodule ... update".
435 while test $# -ne 0
436 do
437 case "$1" in
438 -q|--quiet)
439 GIT_QUIET=1
440 ;;
441 --progress)
442 progress=1
443 ;;
444 -i|--init)
445 init=1
446 ;;
447 --remote)
448 remote=1
449 ;;
450 -N|--no-fetch)
451 nofetch=1
452 ;;
453 -f|--force)
454 force=$1
455 ;;
456 -r|--rebase)
457 update="rebase"
458 ;;
459 --reference)
460 case "$2" in '') usage ;; esac
461 reference="--reference=$2"
462 shift
463 ;;
464 --reference=*)
465 reference="$1"
466 ;;
467 --dissociate)
468 dissociate=1
469 ;;
470 -m|--merge)
471 update="merge"
472 ;;
473 --recursive)
474 recursive=1
475 ;;
476 --checkout)
477 update="checkout"
478 ;;
479 --recommend-shallow)
480 recommend_shallow="--recommend-shallow"
481 ;;
482 --no-recommend-shallow)
483 recommend_shallow="--no-recommend-shallow"
484 ;;
485 --depth)
486 case "$2" in '') usage ;; esac
487 depth="--depth=$2"
488 shift
489 ;;
490 --depth=*)
491 depth=$1
492 ;;
493 -j|--jobs)
494 case "$2" in '') usage ;; esac
495 jobs="--jobs=$2"
496 shift
497 ;;
498 --jobs=*)
499 jobs=$1
500 ;;
501 --)
502 shift
503 break
504 ;;
505 -*)
506 usage
507 ;;
508 *)
509 break
510 ;;
511 esac
512 shift
513 done
514
515 if test -n "$init"
516 then
517 cmd_init "--" "$@" || return
518 fi
519
520 {
521 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
522 ${progress:+"--progress"} \
523 ${wt_prefix:+--prefix "$wt_prefix"} \
524 ${prefix:+--recursive-prefix "$prefix"} \
525 ${update:+--update "$update"} \
526 ${reference:+"$reference"} \
527 ${dissociate:+"--dissociate"} \
528 ${depth:+--depth "$depth"} \
529 $recommend_shallow \
530 $jobs \
531 "$@" || echo "#unmatched" $?
532 } | {
533 err=
534 while read -r mode sha1 stage just_cloned sm_path
535 do
536 die_if_unmatched "$mode" "$sha1"
537
538 name=$(git submodule--helper name "$sm_path") || exit
539 if ! test -z "$update"
540 then
541 update_module=$update
542 else
543 update_module=$(git config submodule."$name".update)
544 if test -z "$update_module"
545 then
546 update_module="checkout"
547 fi
548 fi
549
550 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
551
552 if test $just_cloned -eq 1
553 then
554 subsha1=
555 case "$update_module" in
556 merge | rebase | none)
557 update_module=checkout ;;
558 esac
559 else
560 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
561 git rev-parse --verify HEAD) ||
562 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
563 fi
564
565 if test -n "$remote"
566 then
567 branch=$(git submodule--helper remote-branch "$sm_path")
568 if test -z "$nofetch"
569 then
570 # Fetch remote before determining tracking $sha1
571 fetch_in_submodule "$sm_path" $depth ||
572 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
573 fi
574 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
575 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
576 git rev-parse --verify "${remote_name}/${branch}") ||
577 die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
578 fi
579
580 if test "$subsha1" != "$sha1" || test -n "$force"
581 then
582 subforce=$force
583 # If we don't already have a -f flag and the submodule has never been checked out
584 if test -z "$subsha1" && test -z "$force"
585 then
586 subforce="-f"
587 fi
588
589 if test -z "$nofetch"
590 then
591 # Run fetch only if $sha1 isn't present or it
592 # is not reachable from a ref.
593 is_tip_reachable "$sm_path" "$sha1" ||
594 fetch_in_submodule "$sm_path" $depth ||
595 say "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
596
597 # Now we tried the usual fetch, but $sha1 may
598 # not be reachable from any of the refs
599 is_tip_reachable "$sm_path" "$sha1" ||
600 fetch_in_submodule "$sm_path" $depth "$sha1" ||
601 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
602 fi
603
604 must_die_on_failure=
605 case "$update_module" in
606 checkout)
607 command="git checkout $subforce -q"
608 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
609 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
610 ;;
611 rebase)
612 command="git rebase"
613 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
614 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
615 must_die_on_failure=yes
616 ;;
617 merge)
618 command="git merge"
619 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
620 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
621 must_die_on_failure=yes
622 ;;
623 !*)
624 command="${update_module#!}"
625 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
626 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
627 must_die_on_failure=yes
628 ;;
629 *)
630 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
631 esac
632
633 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
634 then
635 say "$say_msg"
636 elif test -n "$must_die_on_failure"
637 then
638 die_with_status 2 "$die_msg"
639 else
640 err="${err};$die_msg"
641 continue
642 fi
643 fi
644
645 if test -n "$recursive"
646 then
647 (
648 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
649 wt_prefix=
650 sanitize_submodule_env
651 cd "$sm_path" &&
652 eval cmd_update
653 )
654 res=$?
655 if test $res -gt 0
656 then
657 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
658 if test $res -ne 2
659 then
660 err="${err};$die_msg"
661 continue
662 else
663 die_with_status $res "$die_msg"
664 fi
665 fi
666 fi
667 done
668
669 if test -n "$err"
670 then
671 OIFS=$IFS
672 IFS=';'
673 for e in $err
674 do
675 if test -n "$e"
676 then
677 echo >&2 "$e"
678 fi
679 done
680 IFS=$OIFS
681 exit 1
682 fi
683 }
684 }
685
686 #
687 # Show commit summary for submodules in index or working tree
688 #
689 # If '--cached' is given, show summary between index and given commit,
690 # or between working tree and given commit
691 #
692 # $@ = [commit (default 'HEAD'),] requested paths (default all)
693 #
694 cmd_summary() {
695 summary_limit=-1
696 for_status=
697 diff_cmd=diff-index
698
699 # parse $args after "submodule ... summary".
700 while test $# -ne 0
701 do
702 case "$1" in
703 --cached)
704 cached="$1"
705 ;;
706 --files)
707 files="$1"
708 ;;
709 --for-status)
710 for_status="$1"
711 ;;
712 -n|--summary-limit)
713 summary_limit="$2"
714 isnumber "$summary_limit" || usage
715 shift
716 ;;
717 --summary-limit=*)
718 summary_limit="${1#--summary-limit=}"
719 isnumber "$summary_limit" || usage
720 ;;
721 --)
722 shift
723 break
724 ;;
725 -*)
726 usage
727 ;;
728 *)
729 break
730 ;;
731 esac
732 shift
733 done
734
735 test $summary_limit = 0 && return
736
737 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
738 then
739 head=$rev
740 test $# = 0 || shift
741 elif test -z "$1" || test "$1" = "HEAD"
742 then
743 # before the first commit: compare with an empty tree
744 head=$(git hash-object -w -t tree --stdin </dev/null)
745 test -z "$1" || shift
746 else
747 head="HEAD"
748 fi
749
750 if [ -n "$files" ]
751 then
752 test -n "$cached" &&
753 die "$(gettext "The --cached option cannot be used with the --files option")"
754 diff_cmd=diff-files
755 head=
756 fi
757
758 cd_to_toplevel
759 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
760 # Get modified modules cared by user
761 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
762 sane_egrep '^:([0-7]* )?160000' |
763 while read -r mod_src mod_dst sha1_src sha1_dst status sm_path
764 do
765 # Always show modules deleted or type-changed (blob<->module)
766 if test "$status" = D || test "$status" = T
767 then
768 printf '%s\n' "$sm_path"
769 continue
770 fi
771 # Respect the ignore setting for --for-status.
772 if test -n "$for_status"
773 then
774 name=$(git submodule--helper name "$sm_path")
775 ignore_config=$(get_submodule_config "$name" ignore none)
776 test $status != A && test $ignore_config = all && continue
777 fi
778 # Also show added or modified modules which are checked out
779 GIT_DIR="$sm_path/.git" git rev-parse --git-dir >/dev/null 2>&1 &&
780 printf '%s\n' "$sm_path"
781 done
782 )
783
784 test -z "$modules" && return
785
786 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
787 sane_egrep '^:([0-7]* )?160000' |
788 cut -c2- |
789 while read -r mod_src mod_dst sha1_src sha1_dst status name
790 do
791 if test -z "$cached" &&
792 test $sha1_dst = 0000000000000000000000000000000000000000
793 then
794 case "$mod_dst" in
795 160000)
796 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
797 ;;
798 100644 | 100755 | 120000)
799 sha1_dst=$(git hash-object $name)
800 ;;
801 000000)
802 ;; # removed
803 *)
804 # unexpected type
805 eval_gettextln "unexpected mode \$mod_dst" >&2
806 continue ;;
807 esac
808 fi
809 missing_src=
810 missing_dst=
811
812 test $mod_src = 160000 &&
813 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_src^0 >/dev/null &&
814 missing_src=t
815
816 test $mod_dst = 160000 &&
817 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_dst^0 >/dev/null &&
818 missing_dst=t
819
820 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
821
822 total_commits=
823 case "$missing_src,$missing_dst" in
824 t,)
825 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
826 ;;
827 ,t)
828 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
829 ;;
830 t,t)
831 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
832 ;;
833 *)
834 errmsg=
835 total_commits=$(
836 if test $mod_src = 160000 && test $mod_dst = 160000
837 then
838 range="$sha1_src...$sha1_dst"
839 elif test $mod_src = 160000
840 then
841 range=$sha1_src
842 else
843 range=$sha1_dst
844 fi
845 GIT_DIR="$name/.git" \
846 git rev-list --first-parent $range -- | wc -l
847 )
848 total_commits=" ($(($total_commits + 0)))"
849 ;;
850 esac
851
852 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
853 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
854 if test $status = T
855 then
856 blob="$(gettext "blob")"
857 submodule="$(gettext "submodule")"
858 if test $mod_dst = 160000
859 then
860 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
861 else
862 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
863 fi
864 else
865 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
866 fi
867 if test -n "$errmsg"
868 then
869 # Don't give error msg for modification whose dst is not submodule
870 # i.e. deleted or changed to blob
871 test $mod_dst = 160000 && echo "$errmsg"
872 else
873 if test $mod_src = 160000 && test $mod_dst = 160000
874 then
875 limit=
876 test $summary_limit -gt 0 && limit="-$summary_limit"
877 GIT_DIR="$name/.git" \
878 git log $limit --pretty='format: %m %s' \
879 --first-parent $sha1_src...$sha1_dst
880 elif test $mod_dst = 160000
881 then
882 GIT_DIR="$name/.git" \
883 git log --pretty='format: > %s' -1 $sha1_dst
884 else
885 GIT_DIR="$name/.git" \
886 git log --pretty='format: < %s' -1 $sha1_src
887 fi
888 echo
889 fi
890 echo
891 done
892 }
893 #
894 # List all submodules, prefixed with:
895 # - submodule not initialized
896 # + different revision checked out
897 #
898 # If --cached was specified the revision in the index will be printed
899 # instead of the currently checked out revision.
900 #
901 # $@ = requested paths (default to all)
902 #
903 cmd_status()
904 {
905 # parse $args after "submodule ... status".
906 while test $# -ne 0
907 do
908 case "$1" in
909 -q|--quiet)
910 GIT_QUIET=1
911 ;;
912 --cached)
913 cached=1
914 ;;
915 --recursive)
916 recursive=1
917 ;;
918 --)
919 shift
920 break
921 ;;
922 -*)
923 usage
924 ;;
925 *)
926 break
927 ;;
928 esac
929 shift
930 done
931
932 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper status ${GIT_QUIET:+--quiet} ${cached:+--cached} ${recursive:+--recursive} "$@"
933 }
934 #
935 # Sync remote urls for submodules
936 # This makes the value for remote.$remote.url match the value
937 # specified in .gitmodules.
938 #
939 cmd_sync()
940 {
941 while test $# -ne 0
942 do
943 case "$1" in
944 -q|--quiet)
945 GIT_QUIET=1
946 shift
947 ;;
948 --recursive)
949 recursive=1
950 shift
951 ;;
952 --)
953 shift
954 break
955 ;;
956 -*)
957 usage
958 ;;
959 *)
960 break
961 ;;
962 esac
963 done
964
965 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper sync ${GIT_QUIET:+--quiet} ${recursive:+--recursive} "$@"
966 }
967
968 cmd_absorbgitdirs()
969 {
970 git submodule--helper absorb-git-dirs --prefix "$wt_prefix" "$@"
971 }
972
973 # This loop parses the command line arguments to find the
974 # subcommand name to dispatch. Parsing of the subcommand specific
975 # options are primarily done by the subcommand implementations.
976 # Subcommand specific options such as --branch and --cached are
977 # parsed here as well, for backward compatibility.
978
979 while test $# != 0 && test -z "$command"
980 do
981 case "$1" in
982 add | foreach | init | deinit | update | status | summary | sync | absorbgitdirs)
983 command=$1
984 ;;
985 -q|--quiet)
986 GIT_QUIET=1
987 ;;
988 -b|--branch)
989 case "$2" in
990 '')
991 usage
992 ;;
993 esac
994 branch="$2"; shift
995 ;;
996 --cached)
997 cached="$1"
998 ;;
999 --)
1000 break
1001 ;;
1002 -*)
1003 usage
1004 ;;
1005 *)
1006 break
1007 ;;
1008 esac
1009 shift
1010 done
1011
1012 # No command word defaults to "status"
1013 if test -z "$command"
1014 then
1015 if test $# = 0
1016 then
1017 command=status
1018 else
1019 usage
1020 fi
1021 fi
1022
1023 # "-b branch" is accepted only by "add"
1024 if test -n "$branch" && test "$command" != add
1025 then
1026 usage
1027 fi
1028
1029 # "--cached" is accepted only by "status" and "summary"
1030 if test -n "$cached" && test "$command" != status && test "$command" != summary
1031 then
1032 usage
1033 fi
1034
1035 "cmd_$command" "$@"